<?php
$root_path="../";
$title="Gifts Management";
require_once($root_path."inc/begin_code.php");
restrictAccess(3);
require_once($root_path."inc/db.inc.php");
require_once($root_path."inc/config.inc.php");
require_once($root_path."inc/form_pro.inc.php");
require_once($root_path."inc/user.inc.php");
require_once($root_path."inc/ref.inc.php");
include_once($root_path."html/admin/header.html");

define ('RESULTS_PER_PAGE',config::get_value("gifts_per_page"));
if (isset($_POST['submitted']))
{
	$emails=update();
	if (is_array($emails))
	{
		sendEmails($emails);
	}
}

if (getTotalPages() < 1)
{
	echo "<strong>Sorry, there are no gifts to display right now. Please check back later.</strong><br><br>\n";
	die;
}

if ($_GET['page'] > getTotalPages())
{
echo "<strong>No more matches were found.</strong><br><br>\n";
	die;
}	
display();
function getTotalPages()
{
	$db=&new db;
	$sql="SELECT gift_id FROM #_gifts ";
	$rows=$db->get_row_num("gifts",$sql);
	
	if ($rows <1 || RESULTS_PER_PAGE < 1)
	{
		$totalPages=0;
		return $totalPages;
	}
	
	$x=0;
	$totalPages=0;
	while ($x < $rows) {
	$totalPages=$totalPages+1;
	$x=$x+ RESULTS_PER_PAGE;
	}
	return $totalPages;
}


function getCurrentPage()
{
	$currPage=$_GET['page'];
	if (! is_numeric($currPage))
	{
		$currPage=1;
	} elseif ($currPage < getTotalPages())
		{
			$currPage=1;
		}
	return $currPage;
}


function getLimitStart()
{
	$limitStart=0;
	$total=getTotalPages();
	$current=getCurrentPage();
	$limitStart=RESULTS_PER_PAGE * ($current-1);
	return $limitStart;
}


	
function display()
{
		global $root_path;
		$db=&new db;
		$limitStart=getLimitStart();
		$results=RESULTS_PER_PAGE;
		$sql="SELECT gift_id FROM #_gifts ORDER BY rank ASC LIMIT $limitStart,$results";
		
		$giftIds=$db->get_row("gift_id","gifts",$sql);
		
		$sql="SELECT user_id FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$userIds=$db->get_row("user_id","gifts",$sql);
		
		/*$sql="SELECT user_fname FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$fnames=$db->get_row("user_fname","gifts",$sql);*/
		$sql="SELECT filename FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$fileNames=$db->get_row("filename","gifts",$sql);
		
		$sql="SELECT fileurl FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$fileUrls=$db->get_row("fileurl","gifts",$sql);
		
		$sql="SELECT product_name FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$titles=$db->get_row("product_name","gifts",$sql);
		
		$sql="SELECT url FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$urls=$db->get_row("url","gifts",$sql);
		
		$sql="SELECT desc_text_1 FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$desc1=$db->get_row("desc_text_1","gifts",$sql);
	
		$sql="SELECT desc_text_2 FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$desc2=$db->get_row("desc_text_2","gifts",$sql);
		
		$sql="SELECT desc_text_3 FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$desc3=$db->get_row("desc_text_3","gifts",$sql);
		
		$sql="SELECT status FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$status=$db->get_row("status","gifts",$sql);
		
		$sql="SELECT rank FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$ranks=$db->get_row("rank","gifts",$sql);
		
		
		$sql="SELECT forcedRank FROM #_gifts  ORDER BY rank ASC LIMIT $limitStart,$results";
		$forcedRanks=$db->get_row("forcedRank","gifts",$sql);
		
		
		//Trim and stripslah from all of the results
		$uploadDir=form_pro::addHttp(config::get_value('www_gift_upload_dir'));
		$uploadDir=form_pro::addEndingSlash($uploadDir);
		
		foreach ($giftIds as $k=>$v)
		{
			
			//Set the rank to 0 unless its forced:
			$ranks[$k]=($forcedRanks[$k]==1) ? $ranks[$k] : '';
			$giftIds[$k]=trim(stripslashes($v));
			$userIds[$k]=trim(stripslashes($userIds[$k]));
			$fnames[$k]=User::getInfo($userIds[$k],'fname') . ' '.User::getInfo($userIds[$k],'lname');
			$fileNames[$k]=trim(stripslashes($fileNames[$k]));
			$fileUrls[$k]=trim(stripslashes($fileUrls[$k]));
			$titles[$k]=trim(stripslashes($titles[$k]));
			$urls[$k]=trim(stripslashes($urls[$k]));
			$desc1[$k]=trim(stripslashes($desc1[$k]));
			$desc2[$k]=nl2br(trim(stripslashes($desc2[$k])));
			$desc3[$k]=nl2br(trim(stripslashes($desc3[$k])));
			
			if (! empty($fileNames[$k]))
			{
				$imageUrl[$k]=$uploadDir.$fileNames[$k];
			} elseif (! empty($fileUrls[$k]))
			{
				$imageUrl[$k]=$fileUrls[$k];
			} else {
				$imageUrl[$k]=false;
			}
			
			if (strlen($desc1[$k]) > 50)
			{
				$desc1[$k]=substr($desc1[$k],0,35).".....";
			}
			
			if (strlen($desc2[$k]) > 50)
			{
				$desc2[$k]=substr($desc2[$k],0,35).".....";
			}
			
			
			
			if (strlen($desc3[$k]) > 50)
			{
				
				$desc3[$k]=substr($desc3[$k],0,35).".....";
			}
			
			
			
		}
		$total=getTotalPages();
		$current=getCurrentPage();
		include_once($root_path."html/admin/gifts.html");
		return true;
	}
				
	
	function update()
	{
		$db=&new db;
		foreach ($_POST as $k=>$v) 
		{
			
		
			if (eregi('status_',$k))
			{
				$id=substr($k,7);
				$sql="SELECT user_id FROM #_gifts WHERE gift_id='$id' LIMIT 1";
				$userId=$db->getRow('user_id','gifts',$sql);
				//If the delete gift checkbox was checked, just delete and return
				//without doing any more processing.
				if (isset($_POST['delGift_'.$id]))
				{
					delGift($id);
					return true;
				}
				//Check if the admin changed the status of the gift, if yes,
				//get the email of the JV who submitted the gift and email him.
				if ($v=='Approved')
				
				{
					$sql="SELECT status FROM #_gifts WHERE gift_id='$id' LIMIT 1";
					$status=$db->getRow('status','gifts',$sql);
					if ($status !='Approved')
					{
						
						
						$emails[]=User::getInfo($userId,'email');
					}
				}
				
				$rank=$_POST['rank_'.$id];
				
				$sql="UPDATE #_gifts SET status='$v' WHERE gift_id='$id'";
				$db->change_db('gifts',$sql);
				
				if (is_numeric($rank))
				{
////					echo "<font color=green>Changing gift id <b>$id</b>'s rank to $rank</font><p>";
					$sql="UPDATE #_gifts SET rank='$rank',forcedRank='1' WHERE gift_id='$id'";
					$db->change_db('gifts',$sql);
					changeRanks($rank);
				}
				
				if (isset($_POST['undoForcedRank_'.$id]))
				{
					$newRank=Ref::getRank($userId);
					$sql="UPDATE #_gifts SET rank='$newRank',forcedRank='0' WHERE gift_id='$id'";
					$db->change_db('gifts',$sql);
				}
				
			}
		}
		if (is_array($emails))
		{
			return $emails;
		} else {
			return true;
		}
	}
			
	

	
function parse($str,$email)
{
	global $www_path;
	$id=User::getIdByField('email',$email);
	$name=User::getInfo($id,'fname')." ".User::getInfo($id,'lname');
	$loginUrl=$www_path."login.php";
	$ownerName=config::get_value('website_owner_name');
	
	$str=str_replace('[name]',$name,$str);
	$str=str_replace('[login_url]',$loginUrl,$str);
	$str=str_replace('[email]',$email,$str);
	$str=str_replace('[website-owner-name]',$ownerName,$str);
	$str=str_replace('[website]',$www_path,$str);
	return $str;
}


function sendEmails($emails)
{
	global $sitename;
	$msg=config::get_value('gift_Approved_msg');
	$subject=config::get_value('gift_Approved_subject');
	
	foreach ($emails as $k=>$v)
	{
		$subject2=parse($subject,$v);
		$msg2=parse($msg,$v);
		mail($v, $subject2, $msg2, "From: $sitename Admin <admin@$sitename>\nX-Mailer: PHP/" . phpversion());
	}
}

	
function bye() 
{
global $root_path;

	require_once($root_path."inc/end_code.php");
die;
}


function changeRanks($oldRank)
{
	$db=&new db;
	$newRank=$oldRank+1;
	if ($newRank < 1)  return true; //dont set the rank to 0
	$sql="UPDATE #_gifts SET rank='$newRank' WHERE rank='$oldRank' AND forcedRank='0'";
	$db->change_db('gifts',$sql);
	//echo "<h1> ".mysql_affected_rows()." rows affected by $sql</h1>\n";
	return true;
}



function delGift($giftId)
{
	$db=&new db;
	//Get the filename of the image uploaded by the user from the db 
	//so it can be deleted later.
	$sql="SELECT filename FROM #_gifts WHERE gift_id='$giftId' LIMIT 1";
	$file=stripslashes(trim($db->getRow('filename','gifts',$sql)));
	$db->change_db('gifts',"DELETE FROM #_gifts WHERE gift_id='$giftId' LIMIT 1");
	//If no file was uploaded return true
	if ($file=='') return true;
	$fileName=config::get_value('gift_upload_dir').$file;
	@chmod($fileName,0777);//chmod to 777 since by default they're chmoded to 755
	@unlink($fileName);
	return true;
}
	

?>