<?php
require_once($root_path."inc/config.inc.php");

class Uploader
{
	
	
	var $maxSize,$uploadDir,$uploadFile,$imageOnly,$error;
	
	function Upload($uploadFile,$imageOnly)
	{
		
		/* Description of class variables:
		
		$maxSize: maximum file size the uploaded file can have (in bytes)
		
		
		$uploadDir: the directory where the uploaded file will be placed in. Its expected to have a / or \ in the end.
		
		
		$uploadFile: Name of the field in the HTML form which contains the uploaded file, 
		e.g if your form has the line:
		<input type="file" name="myfile">
		then the value of $uploadFile will be: 'myfile'
		
		$imageOnly= boolen, decides if the uploaded file can be image only or can be any file. Supply 0 for false, 1 for true
		
		$error: if an error was found during the validation, its stored in this variable
		
		*/
		
		
		$this->maxSize=config::get_value('gift_upload_max_size');
		$this->uploadDir=config::get_value('gift_upload_dir');
		$this->uploadFile=$uploadFile;
		$this->imageOnly=$imageOnly;
		if ($this->validate())
		{
		$uploadedFile=$this->uploadIt();
		
			return $uploadedFile;
		} else {
				return false;
		}
	}
		
	
	
	function getError()
	{
		if ($this->error) {
			return $this->error;
		}
		$phpErr=$_FILES[$this->uploadFile]['error'];
		
		switch ($phpErr) 
		{
			case 0: 
			$error= false; 
			break;
			
			case 1: 
			$error="Sorry, the file you upload must be less than <b>$sizeInMb MB</b>.";
			break;
			
			case 2:
			$sizeInMb=round(($this->maxSize/1042)/1024);
			$error="Sorry, the file you upload must be less than <b>$sizeInMb MB</b>.";
			break;
			
			case 3:
			$error="The file couldn't be uploaded completely. Please try again.";
			break;
			
			case 4:
			$error="Please select a file to upload.";
			break;
			
			case 5:
			$error="Sorry, file uploads are not allowed on this website.";
			break;
			
			default:
			$error=777;
			break;
			
		}
		return $error;	
	}
	
	function validate()
	{
			$file=$this->uploadFile;
			if ($_FILES[$file]['error'] !=0)
			{
				return false;
			}
			
			if ($_FILES[$file]['size'] > $this->maxSize)
			{
				$sizeInMb=round(($this->maxSize/1042)/1024);
			$this->error="Sorry, the file you upload must be less than <b>$sizeInMb</b>.";
				return false;
			}
			
			if (! is_uploaded_file($_FILES[$file]['tmp_name']))
			{
				$this->error="An error occured when trying to upload your file. Please try again.";
				return false;
			}
			
			if ($this->imageOnly==0)
			{
				return true;
			}
			
			$imageSize=getimagesize($_FILES[$file]['tmp_name']);
			if ($imageSize[2] !=1 && $imageSize[2] !=2 && $imageSize[2] !=3)
			{
				$this->error="The file you provided is not a valid image. Please supply a valid image file (only .jpg, .gif, and .png extensions allowed).";
				return false;
			}
			return true;
	}
	
	function uploadIt()
	{
		
		
		do
		
		{
			$temp=basename($_FILES[$this->uploadFile]['name']);
			$fileName=$this->uploadDir.uniqid(rand()).$temp;
			
		} while (file_exists($fileName));
		
		
	echo "REALP: $fileName " . $_FILES[$this->uploadFile]['tmp_name'];	
		
		if (move_uploaded_file($_FILES[$this->uploadFile]['tmp_name'],$fileName))
		{
			
		chmod($fileName,0755);
		return $fileName;
		} else {
			
			return false;
		}
		
	}
	
}
	?>
